variables:
  GIT_MIRROR_URL: "https://gitlab.com/ayufan-repos/tests/git-bundle-mirror.git"
  GIT_INIT_FLAGS: --initial-branch=main
  GIT_MIRROR_FETCH_FLAGS: main --depth=1000
  GIT_ORIGIN_FETCH_FLAGS: --depth=1000

# Create bundle with differences between mirror and requested change
create-git-bundle:
  variables:
    GIT_STRATEGY: none
  before_script:
    - git init $GIT_INIT_FLAGS "$CI_PROJECT_DIR"
    - git remote add origin "$CI_REPOSITORY_URL" || git remote set-url origin "$CI_REPOSITORY_URL"
    - git remote add mirror "$GIT_MIRROR_URL" || git remote set-url origin "$GIT_MIRROR_URL"
    - git fetch mirror $GIT_MIRROR_FETCH_FLAGS
    - git fetch origin "$CI_COMMIT_SHA" $GIT_ORIGIN_FETCH_FLAGS
  script:
    - git checkout -B "$CI_COMMIT_REF_NAME" "$CI_COMMIT_SHA"
    - git bundle create git-origin.bundle "$(git merge-base mirror/main "$CI_COMMIT_SHA")..$CI_COMMIT_REF_NAME"
  artifacts:
    paths: [git-origin.bundle]

# Restore git tree using only bundle
.restore_using_bundle:
  needs: [create-git-bundle]
  variables:
    GIT_STRATEGY: none
  before_script:
    - git init $GIT_INIT_FLAGS "$CI_PROJECT_DIR"
    - git remote add mirror "$GIT_MIRROR_URL" || git remote set-url origin "$GIT_MIRROR_URL"
    - git fetch mirror $GIT_MIRROR_FETCH_FLAGS
    - git bundle unbundle git-origin.bundle
    - rm -f git-origin.bundle
    - git checkout "$CI_COMMIT_SHA"

# Write CI job
use-repo:
  extends: .restore_using_bundle
  script:
    - echo Hello World
    - git rev-parse HEAD
  parallel: 5
